unit UCommBridge;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.TMSFNCTypes, FMX.TMSFNCUtils, FMX.TMSFNCGraphics, FMX.TMSFNCGraphicsTypes,
  FMX.TMSFNCCustomControl, FMX.TMSFNCWebBrowser;

type
  TForm30 = class(TForm)
    TMSFNCWebBrowser1: TTMSFNCWebBrowser;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form30: TForm30;

implementation

{$R *.fmx}

type
  TRemoteJavaScriptObject = class(TPersistent)
  private
    FObjectMessage: string;
    procedure SetObjectMessage(const Value: string);
  published
    property ObjectMessage: string read FObjectMessage write SetObjectMessage;
  end;

procedure TForm30.FormCreate(Sender: TObject);
const
  BridgeName = 'MyBridge';
var
  sHTML: string;
  o: TRemoteJavaScriptObject;
begin
  sHTML :=
    '<html>' + #13 +
    '  <head>' + #13 +
    '    <script>' + #13 +
         TMSFNCWebBrowser1.GetBridgeCommunicationLayer(BridgeName) +
         '</script>' + #13 +
    '  </head>' + #13 +
    '  <body>' + #13 +
    '    <button onclick="send' + BridgeName + 'ObjectMessage(''Notification from web browser page!'');">Click me!</button>' + #13 +
    '  </body>' + #13 +
    '</html>';

  o := TRemoteJavaScriptObject.Create;
  TMSFNCWebBrowser1.AddBridge(BridgeName, o);
  TMSFNCWebBrowser1.LoadHTML(sHTML);
end;

{ TRemoteJavaScriptObject }

procedure TRemoteJavaScriptObject.SetObjectMessage(const Value: string);
begin
  TTMSFNCUtils.Message(Value);
end;

end.
